<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: structural_assignment_trainer_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">structural_assignment_trainer_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_STRUCTURAL_ASSiGNMENT_TRAINER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_STRUCTURAL_ASSiGNMENT_TRAINER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;structural_svm_assignment_problem.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;assignment_function_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> feature_extractor</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        &gt;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">class </span>structural_assignment_trainer</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> feature_extractor::lhs_element <a class="code" href="classdlib_1_1matrix.html">lhs_element</a>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> feature_extractor::rhs_element <a class="code" href="classdlib_1_1matrix.html">rhs_element</a>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">typedef</span> std::pair&lt;std::vector&lt;lhs_element&gt;, std::vector&lt;rhs_element&gt; &gt; sample_type;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">typedef</span> std::vector&lt;long&gt; label_type;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">typedef</span> assignment_function&lt;feature_extractor&gt; trained_function_type;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        structural_assignment_trainer (</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        );</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">explicit</span> structural_assignment_trainer (</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            <span class="keyword">const</span> feature_extractor&amp; fe</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        );</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">const</span> feature_extractor&amp; get_feature_extractor (</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordtype">void</span> set_num_threads (</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        );</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_threads (</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keywordtype">void</span> set_epsilon (</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordtype">double</span> eps</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        );</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">double</span> get_epsilon (</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keywordtype">void</span> set_max_cache_size (</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_size</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        );</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_max_cache_size (</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keywordtype">void</span> set_loss_per_false_association (</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <span class="keywordtype">double</span> loss</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        );</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordtype">double</span> get_loss_per_false_association (</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keywordtype">void</span> set_loss_per_missed_association (</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="keywordtype">double</span> loss</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        );</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <span class="keywordtype">double</span> get_loss_per_missed_association (</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordtype">void</span> be_verbose (</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        );</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordtype">void</span> be_quiet (</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        );</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="keywordtype">void</span> set_oca (</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            <span class="keyword">const</span> oca&amp; item</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        );</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keyword">const</span> oca get_oca (</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        <span class="keywordtype">void</span> set_c (</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="keywordtype">double</span> C </div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        );</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordtype">double</span> get_c (</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordtype">void</span> set_forces_assignment (</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            <span class="keywordtype">bool</span> new_value</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        );</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <span class="keywordtype">bool</span> forces_assignment(</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keywordtype">bool</span> forces_last_weight_to_1 (</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="keywordtype">void</span> force_last_weight_to_1 (</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;            <span class="keywordtype">bool</span> should_last_weight_be_1</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        );</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keyword">const</span> assignment_function&lt;feature_extractor&gt; train (  </div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            <span class="keyword">const</span> std::vector&lt;sample_type&gt;&amp; samples,</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            <span class="keyword">const</span> std::vector&lt;label_type&gt;&amp; labels</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    };</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160; </div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160; </div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;}</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="preprocessor">#endif // DLIB_STRUCTURAL_ASSiGNMENT_TRAINER_ABSTRACT_Hh_</span></div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160; </div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix</a></div><div class="ttdef"><b>Definition:</b> matrix/matrix.h:991</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
